<template>
  <div class="container player-view">
    <div class="tile is-ancestor">
      <div class="tile is-vertical is-8">
        <div class="tile">
          <div class="tile is-parent">
            <article class="tile is-child notification is-info">
              <p class="title">{{ playerName }}</p>
              <p class="subtitle">{{ player?.team.full_name || '' }}</p>
              <div class="content">
                <Level :items="stats" />
                <progress v-if="playerLoading" class="progress is-small is-primary" max="100">15%</progress>
              </div>
            </article>
          </div>
        </div>
        <div class="tile is-parent">
          <article class="tile is-child notification">
            <p class="title">Games played</p>
            <p class="subtitle">{{ FROM_SEASON }} - {{ TO_SEASON }}</p>
            <div class="content">
              <div ref="chart"></div>
              <Message v-if="chartError" header="Error" type="danger">Failed to load data</Message>
            </div>
          </article>
        </div>
      </div>
      <div class="tile is-parent">
        <article class="tile is-child notification">
          <div class="content">
            <p class="title">Season averages</p>
            <p class="subtitle">{{ DEFAULT_SEASON }}</p>
            <div class="content">
              <Table :config="seasonAveragesTableConfig" :items="seasonAverages" :loading="seasonAveragesLoading" />
            </div>
          </div>
        </article>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, computed, watch, onMounted, ref } from 'vue'
import { useRoute } from 'vue-router'
import { useStore, ActionTypes, LoadingState } from '@/store/index'
import { useLineChart } from '@/composables/chart'
import { footInches, arrayFromRange } from '@/utils'
import Table from '@/components/Table.vue'
import Level from '@/components/Level.vue'
import Message from '@/components/Message.vue'

const DEFAULT_SEASON = 2020
const FROM_SEASON = 2015
const TO_SEASON = 2020

export default defineComponent({
  name: 'PlayerView',
  components: { Table, Level, Message },
  setup() {
    const route = useRoute()
    const store = useStore()
    const chart = ref<HTMLElement>()
    const chartSeries = ref<number[]>([])
    const seasons = arrayFromRange(FROM_SEASON, TO_SEASON)

    watch(
      () => route,
      (to) => {
        const id = +to.params.id

        if (!Number.isNaN(id)) {
          store.dispatch(ActionTypes.GetPlayer, { id })
          store.dispatch(ActionTypes.GetSeasonAverages, { id, from: FROM_SEASON, to: TO_SEASON })
        }
      },
      { immediate: true }
    )

    watch(
      () => store.getters.playerGamesPerSeason,
      (playerGamesPerSeason) => {
        chartSeries.value = playerGamesPerSeason.map(({ games }) => games)
      }
    )

    const player = computed(() => store.state.singlePlayer)
    const playerLoading = computed(() => store.state.singlePlayerLoading)
    const playerName = computed(() => (player.value ? `${player.value?.first_name} ${player.value?.last_name}` : ''))
    const stats = computed(() => {
      const weightPounds = player.value?.weight_pounds

      return [
        {
          heading: 'Position',
          value: player.value?.position,
        },
        {
          heading: 'Games played',
          value: footInches(player.value?.height_feet, player.value?.height_inches),
        },
        {
          heading: 'Season averages',
          value: weightPounds ? `${weightPounds} lb.` : '-',
        },
      ]
    })
    const seasonAverages = computed(() =>
      Object.entries({ ...store.state.seasonAverages[DEFAULT_SEASON] }).map(([label, value]) => ({ label, value }))
    )
    const seasonAveragesLoading = computed(() => store.state.seasonAveragesLoading === LoadingState.LOADING)
    const seasonAveragesTableConfig = {
      columns: {
        label: {
          title: 'Parameter',
        },
        value: {
          title: 'Value',
        },
      },
    }

    const chartError = computed(
      () =>
        chartSeries.value.length !== seasons.length &&
        [LoadingState.SUCCESS, LoadingState.ERROR].includes(store.state.seasonAveragesLoading)
    )

    onMounted(() => {
      if (chart.value) {
        const { render } = useLineChart(chart.value, 'Games', chartSeries, seasons)

        render()
      }
    })

    return {
      DEFAULT_SEASON,
      FROM_SEASON,
      TO_SEASON,
      player,
      playerLoading,
      playerName,
      stats,
      seasonAverages,
      seasonAveragesLoading,
      seasonAveragesTableConfig,
      chart,
      chartError,
    }
  },
})
</script>
